#include "stm32u083.hpp"

int main()
{
    using namespace STM32U083;
    using LD3 = GPIOC::ODR::OD13;
    using LD4 = GPIOA::ODR::OD5;
    using LD5 = GPIOB::ODR::OD2;

    RCC::ALL::set<
        RCC::IOPENR::GPIOAEN,
        RCC::IOPENR::GPIOBEN,
        RCC::IOPENR::GPIOCEN,
        RCC::APBENR1::USART2EN>();

    GPIOC::MODER::MODE13::write<1>();
    GPIOA::MODER::MODE5::write<1>();
    GPIOB::MODER::MODE2::write<1>();

    unsigned i = 0;
    while (1) {
        if (i & 1) LD3::set(); else LD3::clear();
        if (i & 2) LD4::set(); else LD4::clear();
        if (i & 4) LD5::set(); else LD5::clear();

        for (int j = 0; j < 100000; j++)
            asm("nop");

        i++;
    }
}

